% feature extraction for all images of ETH Synthesizability
% Note all computed features are provided in 
%   "./ETH_Synthesizability/features/"
% by Dengxin Dai (dai@vision.ee.ethz.ch) at ETH Zurich
% Oct. 2013
%%  

addpath(genpath('./libs/')); 
addpath(genpath('./features/')); 
addpath(genpath('./models/')); 

fet_set = {'textureness',  'homogeneity', 'repetitiveness', 'irregularity', ...
    'Sfilter', 'lbp', 'gist'}; 

data_path = './ETH_Synthesizability/texture/'; 
fet_path =  './ETH_Synthesizability/feature_test/'; % save features
load('./ETH_Synthesizability/annotation/synthesizability_labeling.mat');

vl_setup; 
img_num = length(TEXTURE); 


for n=1:img_num                 % over all imgs 
 
     img = imread(strcat(data_path, TEXTURE(n).name, '.jpg')); 
       
     for i=1:length(fet_set)             % over all features
         
       fname = fet_set{i}; 
       if ~exist(strcat(fet_path, fname, '/', TEXTURE(n).name, '.mat'), 'file')  %already computed
          
           fet = feature_compute(img, fname);
           
           % folder storing fets
           fet_folder = fileparts(strcat(fet_path, fname, '/', TEXTURE(n).name)); 
           if ~exist(fet_folder) mkdir(fet_folder); end
           
           save(strcat(fet_path, fname, '/', TEXTURE(n).name, '.mat'), 'fet'); 
       end
       
     end
end

