% by dengxin dai
function fet = feature_compute(img, fet_name)

fprintf('starts computing %s \n', fet_name); 

switch fet_name

    case 'textureness'    
        fet = textureness_img(img);
          
    case 'homogeneity'     
        word_num = 30; psize = 10; 
        fet = homogeneity_img(img, word_num, psize);
        
    case 'repetitiveness'   
        fet = repetitiveness_img(img);
        
    case 'irregularity' 
        fet = irregularity_run_fast_img(img); 
        
    case 'Sfilter' 
        fet = Sfilter_img(img); 
  
    case 'lbp' 
        fet = lbp_img(img);

        
    case 'gist'
        fet = gist_img(img);  
        
    otherwise
        error('feature does not exist'); 
end

fprintf('%s finished \n', fet_name);
end


       % patch complexity 
% % % %        fname = 'patch_complexity'; 
% % % %        if ~exist(strcat(fet_path, fname, '/', TEXTURE(img_ind(n)).name, '.mat'), 'file')  
% % % %            psize = 20; 
% % % %            ratio = [0.1 0.3 0.5 0.8 0.9]; 
% % % %            f_patch_complexity = pca_complexity_img(img, psize, ratio); 
% % % %            if ~exist(strcat(fet_path, fname, '/')) mkdir(strcat(fet_path, fname, '/')); end
% % % %            save(strcat(fet_path, fname, '/', TEXTURE(img_ind(n)).name, '.mat'), 'f_patch_complexity'); 
% % % %        end
