
% imPath = '/scratch_net/pengyou/experiments/synthesizableness/TexSyn13/feature/Patch/'; 
% resultPath = '/scratch_net/pengyou/experiments/synthesizableness/TexSyn13/feature/repetitiveness/'; 
% imgSet = dir(strcat(imPath, '*.mat'));
% imgNum = length(imgSet);
 

%generate patches & calculate features for patches of a dataset 
function f_homogeneity = homogeneity_img(img, word_num, psize)


%word_num = 20; 

    % obtain all patches 
   
    pstep = max(1, round(psize/3)); %=1;

    img = double(img);
    
    [img_h, img_w, img_z] = size(img); 
    
    
    [pf, ind_x, ind_y, num_x, num_y] = patchExtraction(img, int32(img_z), int32(psize), int32(pstep)); 
    num_p = num_x*num_y;
    pf = reshape(pf, [psize.^2*img_z num_p]);     % 
    pf = permute(pf, [2 1]);
    pf = double(pf); 
    
    
    max_x = num_x;
    max_y = num_y; 
        
    cording_error = []; 
    hist_dis = []; 
    iterNum = 80; 
    
    [ccenters, cindex] = kmeans(pf', word_num); 
    if numel(unique(cindex)) ~= word_num
       rand_ind = randperm(num_p); 
       ccenters = pf(rand_ind(1:word_num), :)';   
    end
    
    for i=1:iterNum  % cording error sampling, 
        rect_w = round(max_x/3);  % width & height 
        rect_h = round(max_y/3);
        rect_x = randi(max_x-rect_w-1);                    % coords of top-left corner
        rect_y = randi(max_y-rect_h-1);
        
        inside_ind  = find(ind_x>rect_x & ind_x<rect_x+rect_w & ind_y>rect_y & ind_y<rect_y + rect_h); 

        
        rect_w = round(max_x/3);  % width & height 
        rect_h = round(max_y/3);
        rect_x = randi(max_x-rect_w-1);                    % coords of top-left corner
        rect_y = randi(max_y-rect_h-1);
        
        outside_ind  = find(ind_x>rect_x & ind_x<rect_x+rect_w & ind_y>rect_y & ind_y<rect_y + rect_h); 
        
        
        [cording_error_i1, inside_cindex] = knn(double(pf(inside_ind,:)'), ccenters, 1); 
        [cording_error_i2, outside_cindex] = knn(double(pf(outside_ind,:)'), ccenters, 1);  
% %         
% %         cording_error(i) = mean(cording_error_i2)/mean(cording_error_i1); 
        
        
        inside_indhist = normalize(hist(inside_cindex, 1:word_num)',1); 
        outside_indhist = normalize(hist(outside_cindex, 1:word_num)', 1);
        
        hist_dis(i) = pdist2(inside_indhist', outside_indhist').^0.5; 
        
    end
    
%     cording_error = cording_error(:); 
%     hist_dis = hist_dis(:);
%     cording_error = cording_error./iterNum; 
%     hist_dis = hist_dis./iterNum; 
    
    f_homogeneity = 1./(mean(hist_dis(:)) + exp(-10)); 

end