%repetitiveness by cross-correlation distance

function f_repetitiveness = repetitiveness_img(I)

   [img_h, img_w, img_z] = size(I);
   if (img_z==3) I = double(rgb2gray(I)); end
   I = double(I);   
   
% %    I_mean = mean2(I);    % normalize the image via its standard variance 
% %    I_std = std2(I); 
% %    I = (I-repmat(I_mean, [img_h img_w 1])) ./ I_std .* 255;
      
   I_ones = ones(size(I,1), size(I,2));
   C_ones = conv2(I_ones, I_ones);
   
%    expI = exp(double(I));  
%    neg_expI = exp(-double(I))
      
    dist_mat = sqrt(conv2(double(I_ones), double(I).^2) - 2*conv2(I, I) + conv2(double(I).^2, (I_ones)));
    dist_mat = dist_mat(1/6*end:5/6*end, 1/6*end:5/6*end);   % throw away the unreliable borders
    C_ones = C_ones(1/6*end:5/6*end, 1/6*end:5/6*end); 
    dist_mat = dist_mat./C_ones;                              %normalized by the number of pixels involved 


    [H, W, Z] = size(dist_mat); 
    
    rect_w = round(W/5);  % width & height 
    rect_h = round(H/5);
  
    dis_max = []; 
    dis_min = [];
    
    iterNum = 80; 
    for i=1:iterNum  % cording error sampling, 

        rect_x = randi(W-rect_w-1);                    % coords of top-left corner
        rect_y = randi(H-rect_h-1);
        patch_dis = dist_mat(rect_y:rect_y+rect_h-1, rect_x:rect_x+rect_w-1); 

        dis_max(i) = max(patch_dis(:));
        dis_min(i) = min(patch_dis(:));
    end
  
    
    
    ratio_mm = dis_max./(dis_min + exp(-10)); 
    
% % % % %     [xxx, ind] = sort(dis_min(:), 'ascend');
% % % % %     
% % % % %     dis_max  = dis_max(ind(end/4:end));
% % % % %     ratio_mm = ratio_mm(ind(end/4:end)); 
    
    f_repetitiveness = mean(ratio_mm(:) + exp(-10))/std((dis_min(:)) + exp(-10));
 
% % subplot(2, 2, 1); 
% % imshow(uint8(I));
% % subplot(2, 2, 2);
% % imagesc(C); 
% % subplot(2, 2, 3);
% % imagesc(dist_mat);
% % subplot(2, 2, 4);
% % imagesc(dist_mat./C_ones);
%    save(strcat(resultPath, imgSet(n).name(1:end-4), '.mat'), 'regu_fft'); 
end
