% train texture_ness classfication model 
% get the textureness of images via classification: positive uiuc, negative
% scene 15
clear all, clc; 
addpath(genpath('/scratch/Dai/Code/matlab_lib/lib_daid/')); 
addpath(genpath('/scratch/Dai/Code/synthesizability_cvpr14/')); 

set_name1 = '25';  % dataset_name, {'15', '21', '25',  '101'}
set_name2 = '15';  % dataset_name, {'15', '21', '25',  '101'}

fet_name = 'gist'; % feature_name {'gist', 'phog', 'lbp', 'all'}, where all is the concatenation of gist, phog, and lbp

data_dir = '/scratch/Dai/Code/EnPro/data/';    
fet_dir = './feature/';

%% loading data  
data_name = strcat( data_dir, set_name1, '_', fet_name, '.mat');        
load(data_name);
img_fet  =  data.fet;                    
img_lab  = ones(length(data.lab), 1);    % positive 

data_name = strcat(data_dir, set_name2, '_', fet_name, '.mat');        
load(data_name);
img_fet  =  cat(1, img_fet, data.fet);                    % the feature itself for ep   

img_lab  =  cat(1, img_lab, zeros(length(data.lab), 1));

img_num = length(img_lab(:)); 

%%    
LRC_model = svmtrain(sparse(img_lab),sparse(img_fet), '-t 0  -c 10');
[plabel, acc, prob_es] = svmpredict(sparse(img_lab),sparse(img_fet), LRC_model);    

save('Textureness_classification_model.mat', 'LRC_model')   ;
disp('finished:'); 
